diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 000000000..3265517e9
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,317 @@
+require "json"
+require "net/http"
+require "uri"
+require "hive/config"
+require "hive/invoked_binary"
+require "hive/commands/setup/backend_prompt"
+require "hive/commands/setup/dependency_check"
+
+module Hive
+  module Commands
+    # `hive setup` — one-shot full local (non-Docker) setup for the Hive
+    # web UI. Orchestrates, in order:
+    #
+    #   1. (interactive, TTY only) global backend selection via
+    #      Setup::BackendPrompt → persisted via Config.write_global_agents!.
+    #   2. Dependency verification + Hive-owned bootstrap (U3).
+    #   3. Daemon service ensure — the daemon unit is (re)written pointing
+    #      at the SAME hive binary/version as the CLI (U5).
+    #   4. Project enrollment — if run inside a git repo that isn't yet
+    #      registered, register it (never force-init / prompt). Full
+    #      `.hive-state` bootstrap stays the explicit `hive init` step.
+    #   5. Web service ensure (U1) — autostart enabled (a foreground run is
+    #      the manual alternative).
+    #   6. Health check at http://127.0.0.1:<port>/health?deep=1 (only when
+    #      the web service is reachable).
+    #
+    # Each step carries `{name, status, detail}` into a hive-setup.v1 JSON
+    # envelope (--json) or a human summary. All collaborators are injectable
+    # so the flow is unit-testable without a real daemon / web service /
+    # health probe.
+    #
+    # `hive setup` never silently installs / authenticates external agent
+    # CLIs (gh/claude/codex) — the dependency step reports exact fix
+    # commands, and a missing/failing external dep puts the run in the
+    # "fix required" return bucket without aborting the Hive-owned steps.
+    class Setup
+      EXIT_OK = Hive::ExitCodes::SUCCESS
+      EXIT_FIX_REQUIRED = Hive::ExitCodes::FIX_REQUIRED
+
+      # Inject a fake health probe for tests; the default is a real HTTP GET
+      # to the configured web origin accepting loopback.
+      def initialize(json: false, non_interactive: false, bind: nil, port: nil,
+                     output: $stdout, input: $stdin,
+                     backend_prompt: nil, dependency_check: nil,
+                     daemon_installer: nil, web_installer: nil, health: nil,
+                     app_dir: nil, data_home: nil,
+                     runner: nil)
+        @json = json
+        @non_interactive = non_interactive || !input.respond_to?(:tty?) || !input.tty?
+        @bind = bind
+        @port = port
+        @output = output
+        @input = input
+        @backend_prompt = backend_prompt
+        @dependency_check = dependency_check
+        @daemon_installer = daemon_installer
+        @web_installer = web_installer
+        @health = health
+        @app_dir = app_dir
+        @data_home = data_home
+        @runner = runner || ->(argv) { system(*argv, out: File::NULL) }
+        @steps = []
+        @ok = true
+        @dep_results = nil
+        @backend_selection = nil
+        @web_health = nil
+      end
+
+      def call
+        run_backend_selection
+        run_dependency_check
+        ensure_daemon
+        enroll_project
+        ensure_web
+        run_health
+
+        if @json
+          @output.puts JSON.generate(envelope)
+        else
+          render_summary
+        end
+
+        @ok ? EXIT_OK : EXIT_FIX_REQUIRED
+      end
+
+      private
+
+      def run_backend_selection
+        begin
+          prompt = @backend_prompt
+          unless prompt
+            prompt = BackendPrompt.new(input: @input, output: $stderr, summary_io: @output)
+          end
+          @backend_selection = @non_interactive ? default_backends : prompt.collect
+          step("backends", "ok", "global backends: #{@backend_selection.join(', ')}")
+          Hive::Config.write_global_agents!(@backend_selection)
+        rescue BackendPrompt::Aborted => e
+          @ok = false
+          step("backends", "aborted", e.message)
+        rescue ArgumentError, Hive::ConfigError => e
+          @ok = false
+          step("backends", "failed", e.message)
+        end
+      end
+
+      # Non-interactive default selection without a live registry dependency.
+      def default_backends
+        Hive::Config.default_global_agents
+      end
+
+      def run_dependency_check
+        check = @dependency_check
+        unless check
+          check = DependencyCheck.new(
+            json: false,
+            # In --json mode the per-step info rides the setup envelope; keep
+            # stdout pure JSON by sending the dependency table to stderr
+            # (never stdout).
+            output: @json ? $stderr : @output,
+            app_dir: @app_dir || rails_app_dir, data_home: @data_home,
+            bootstrap: true
+          )
+        end
+        check.call
+        @dep_results = { rows: check.rows, bootstrap: check.bootstrap_actions,
+                         ok: check.rows.none? { |r| failing_row?(r) } }
+        step("dependencies", @dep_results[:ok] ? "ok" : "fix_required",
+             "#{check.rows.count { |r| failing_row?(r) }} failing")
+        @ok &&= @dep_results[:ok]
+      end
+
+      def failing_row?(row)
+        %w[missing version_too_old auth_missing bundle_failed broken].include?(row[:status])
+      end
+
+      def ensure_daemon
+        installer = @daemon_installer
+        unless installer
+          require "hive/commands/daemon/service_installer"
+          installer = Hive::Commands::Daemon::ServiceInstaller.new(
+            binary_path: Hive::InvokedBinary.path
+          )
+        end
+        outcome = installer.install!(autostart: true, force: false)
+        # Drift without --force is reported, not auto-overwritten.
+        if outcome.success?
+          step("daemon", "ok", "daemon unit #{outcome.wire_outcome} at #{installer.target_path}")
+        elsif outcome.drifted?
+          @ok = false
+          step("daemon", "drifted",
+               "daemon unit differs from template — run `hive daemon install --force` (backup saved)")
+        else
+          @ok = false
+          step("daemon", "failed", "daemon service install reported #{outcome.wire_outcome}")
+        end
+      rescue StandardError => e
+        @ok = false
+        step("daemon", "failed", "#{e.class}: #{e.message}")
+      end
+
+      def enroll_project
+        root = current_repo_root
+        unless root
+          step("enroll", "skipped", "not inside a git repo; enrollment skipped")
+          return
+        end
+        registered = Hive::Config.registered_projects.any? { |p| File.expand_path(p["path"]) == root }
+        if registered
+          step("enroll", "ok", "current repo already registered")
+        else
+          # Enroll (register) the current repo now, never a bare hint: the
+          # one-shot setup contract requires the repo to be enrolled on exit,
+          # not merely told how. Full `.hive-state` bootstrap (worktree +
+          # stage scaffolding) stays the explicit `hive init` step — setup
+          # only registers so status/TUI/web and the daemon see the repo
+          # immediately, without force-initing or prompting.
+          Hive::Config.register_project(name: File.basename(root), path: root)
+          step("enroll", "ok",
+               "registered #{File.basename(root)} at #{root} (run `hive init #{root}` for full bootstrap)")
+        end
+      rescue Hive::ConfigError => e
+        @ok = false
+        step("enroll", "failed", e.message)
+      end
+
+      def ensure_web
+        installer = @web_installer
+        unless installer
+          require "hive/commands/web/service_installer"
+          installer = Hive::Commands::Web::ServiceInstaller.new(
+            binary_path: Hive::InvokedBinary.path
+          )
+        end
+        outcome = installer.install!(autostart: true, force: false)
+        if outcome.success?
+          step("web", "ok", "web unit #{outcome.wire_outcome} at #{installer.target_path}")
+        elsif outcome.drifted?
+          @ok = false
+          step("web", "drifted",
+               "web unit differs from template — run `hive web install --force` (backup saved)")
+        else
+          @ok = false
+          step("web", "failed", "web service install reported #{outcome.wire_outcome}")
+        end
+        step("web", "hint", "autostart enabled; for a foreground server, run `hive web run`")
+      rescue StandardError => e
+        @ok = false
+        step("web", "failed", "#{e.class}: #{e.message}")
+      end
+
+      def run_health
+        origin = web_origin
+        return step("health", "skipped", "no web origin") unless origin
+
+        health = @health
+        unless health
+          health = lambda do |url|
+            resp = Net::HTTP.get_response(URI(url))
+            body = JSON.parse(resp.body) rescue {}
+            { ok: resp.is_a?(Net::HTTPSuccess), status: resp.code.to_i, body: body }
+          rescue StandardError
+            { ok: false, status: nil, body: {} }
+          end
+        end
+
+        @web_health = health.call(origin)
+        # The daemon health probe returns 503 when the daemon is down; that
+        # is an informational (still constructed) state, not a setup failure.
+        step("health", @web_health[:ok] ? "ok" : "warning",
+             "GET #{origin} → #{@web_health[:status] || 'unreachable'}")
+      end
+
+      def web_origin
+        cfg = Hive::Config.load_global_web
+        bind = @bind || cfg.fetch("bind")
+        port = (@port || cfg.fetch("port")).to_i
+        scheme = "http"
+        # IPv6 loopback (`::1`) must be bracketed in a URL; a bare `::1`
+        # would parse as a bogus host:port split (`http://::1:4567`).
+        host = bind.to_s.include?(":") ? "[#{bind}]" : bind.to_s
+        "#{scheme}://#{host}:#{port}/health?deep=1"
+      rescue StandardError
+        nil
+      end
+
+      def rails_app_dir
+        candidates = [
+          ENV["HIVEBOX_WEB_APP_DIR"],
+          File.expand_path("../../../web", __dir__)
+        ].compact
+        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+      end
+
+      def current_repo_root
+        dir = Dir.pwd
+        loop do
+          # A git worktree keeps `.git` as a FILE (gitdir pointer), not a
+          # directory — accept either so `hive setup` enrolls inside worktrees
+          # (where hive tasks actually run) as well as the main checkout.
+          return dir if File.directory?(File.join(dir, ".git")) || File.exist?(File.join(dir, ".git"))
+          parent = File.dirname(dir)
+          return nil if parent == dir
+          dir = parent
+        end
+      end
+
+      def step(name, status, detail)
+        @steps << { "name" => name, "status" => status, "detail" => detail }
+      end
+
+      def envelope
+        {
+          "schema" => "hive-setup",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-setup"),
+          "ok" => @ok,
+          "exit_code" => @ok ? EXIT_OK : EXIT_FIX_REQUIRED,
+          "backend_selection" => @backend_selection,
+          "steps" => @steps,
+          "dependencies" => dependency_wire,
+          "health" => @web_health
+        }
+      end
+
+      def dependency_wire
+        return nil unless @dep_results
+
+        {
+          "ok" => @dep_results[:ok],
+          "rows" => @dep_results[:rows].map { |r| dependency_row_wire(r) },
+          "bootstrap" => @dep_results[:bootstrap]
+        }
+      end
+
+      def dependency_row_wire(row)
+        {
+          "name" => row[:name],
+          "status" => row[:status],
+          "detail" => row[:detail],
+          "fix_command" => row[:fix_command],
+          "hive_owned" => row[:hive_owned]
+        }
+      end
+
+      def render_summary
+        @output.puts "hive setup:"
+        @steps.each { |s| @output.puts "  #{s['status'].ljust(12)} #{s['name']}: #{s['detail']}" }
+        verdict =
+          if @ok
+            "complete (web and daemon services installed and started)"
+          else
+            "fix required — see steps above (external agent CLIs are never auto-installed or auto-authenticated)"
+          end
+        @output.puts "hive setup: #{verdict}"
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/setup/dependency_check.rb b/lib/hive/commands/setup/dependency_check.rb
new file mode 100644
index 000000000..1398cd15c
--- /dev/null
+++ b/lib/hive/commands/setup/dependency_check.rb
@@ -0,0 +1,324 @@
+require "json"
+require "open3"
+require "hive/config"
+
+module Hive
+  module Commands
+    class Setup
+      # U3 dependency verification + Hive-owned bootstrap for `hive setup`.
+      #
+      # Probes the deps `hive setup` needs (Ruby 3.4, git, tmux, gh, claude,
+      # codex, Node/npm/qmd, the Rails web bundle, SQLite), renders a row
+      # table (or a `hive-dependency-check` JSON envelope with --json), and
+      # emits an EXACT fix command for whatever is missing — WITHOUT silently
+      # installing or authenticating anything.
+      #
+      # Two classes of dep:
+      #   - Hive-owned (qmd, the web bundle): `hive setup` MAY bootstrap these
+      #     (gated on the bootstrap: flag; qmd repair only when npm is
+      #     present, bundle install only for a real app dir).
+      #   - External agent CLIs (gh / claude / codex) + base tools (git/tmux/
+      #     sqlite/node/ruby): probed only. Never auto-installed or
+      #     authenticated — the fix command is printed for the operator.
+      #
+      # All collaborators (runner / which) are injectable so unit tests never
+      # spawn a real external CLI.
+      class DependencyCheck
+        EXIT_OK = Hive::ExitCodes::SUCCESS
+        # Missing / too-old / unauthenticated → named non-zero so `hive setup`
+        # (and agents) can branch on "fix required" without parsing prose.
+        EXIT_FIX_REQUIRED = Hive::ExitCodes::FIX_REQUIRED
+
+        # Ruby >= 3.4 is the minimum supported.
+        MIN_RUBY = "3.4".freeze
+
+        def initialize(json: false, output: $stdout,
+                       runner: nil, qmd_runner: nil, which: nil,
+                       app_dir: nil, data_home: nil, bootstrap: false)
+          @json = json
+          @output = output
+          @runner = runner || default_runner
+          @qmd_runner = qmd_runner || @runner
+          @which = which || method(:which_lookup)
+          @app_dir = app_dir
+          @data_home = data_home || Hive::Paths.data_home
+          @bootstrap = bootstrap
+          @rows = nil
+          @bootstrap_actions = []
+        end
+
+        # Exposes the probed rows after #call. Lets the Setup orchestrator
+        # inspect bootstrap decisions without re-running probes.
+        attr_reader :rows, :bootstrap_actions
+
+        def call
+          @rows = [
+            check_ruby,
+            check_git,
+            check_tmux,
+            check_gh,
+            check_claude,
+            check_codex,
+            check_node,
+            check_npm,
+            check_qmd,
+            check_bundle,
+            check_sqlite
+          ].flatten.compact
+
+          bootstrap_hive_owned! if @bootstrap
+
+          if @json
+            @output.puts JSON.generate(envelope)
+          else
+            render_table
+          end
+
+          @rows.any? { |r| failing_row?(r) } ? EXIT_FIX_REQUIRED : EXIT_OK
+        end
+
+        private
+
+        def default_runner
+          lambda do |argv|
+            out, err, status = Open3.capture3(*argv)
+            { success: status.success?, out: out, err: err, status: status.exitstatus }
+          end
+        end
+
+        def which_lookup(name)
+          ENV["PATH"].to_s.split(File::PATH_SEPARATOR).each do |dir|
+            path = File.join(dir, name)
+            return path if File.file?(path) && File.executable?(path)
+          end
+          nil
+        end
+
+        def failing_row?(row)
+          %w[missing version_too_old auth_missing bundle_failed broken].include?(row[:status])
+        end
+
+        def row(name, status, detail, fix: nil, hive_owned: false)
+          { name: name, status: status, detail: detail, fix_command: fix, hive_owned: hive_owned }
+        end
+
+        def check_ruby
+          ruby = @which.call("ruby")
+          return row("ruby", "missing", "ruby not on PATH", fix: "install Ruby 3.4+ (see install.md)") unless ruby
+
+          version = parse_cli_version(@runner.call([ "ruby", "--version" ])[:out])
+          ok = version && version.split(".").first.to_i >= 3 && version.split(".")[1].to_i >= 4
+          return row("ruby", "version_too_old", "found #{version || 'unknown'} at #{ruby} (need >= 3.4)",
+                     fix: "install Ruby 3.4+ (see install.md)") unless ok
+
+          row("ruby", "present", "ruby #{version} at #{ruby}")
+        end
+
+        def check_git
+          git = @which.call("git")
+          return row("git", "missing", "git not on PATH", fix: "install git (see install.md)") unless git
+
+          row("git", "present", "git at #{git}")
+        end
+
+        def check_tmux
+          tmux = @which.call("tmux")
+          return row("tmux", "missing", "tmux not on PATH", fix: "install tmux (see install.md)") unless tmux
+
+          row("tmux", "present", "tmux at #{tmux}")
+        end
+
+        def check_gh
+          gh = @which.call("gh")
+          return row("gh", "missing", "gh CLI not on PATH",
+                     fix: "brew install gh / install from https://cli.github.com") unless gh
+
+          probe = @runner.call(%w[gh auth status])
+          return row("gh", "present", "gh at #{gh}") if probe[:success]
+
+          detail = "gh installed but not authenticated"
+          detail += " (exit #{probe[:status]})" unless probe[:status].nil?
+          row("gh", "auth_missing", detail, fix: "gh auth login")
+        end
+
+        def check_claude
+          claude = @which.call("claude")
+          return row("claude", "missing", "claude CLI not on PATH",
+                     fix: "install Claude Code (see install.md); then `claude setup-token`") unless claude
+
+          probe = @runner.call(%W[#{claude} --version])
+          return row("claude", "present", "claude at #{claude}") if probe[:success]
+
+          # `--version` is NOT an auth probe — a failing --version means the
+          # CLI is broken/not runnable (bad install, missing deps, a
+          # network-failing shim), not an unauthenticated account. Report it
+          # as a broken install rather than auth_missing with a misleading
+          # auth fix command.
+          row("claude", "broken", "claude at #{claude} failed to run (--version)",
+              fix: "reinstall Claude Code (see install.md)")
+        end
+
+        def check_codex
+          codex = @which.call("codex")
+          return row("codex", "missing", "codex CLI not on PATH",
+                     fix: "install OpenAI Codex; then `codex login --device-auth`") unless codex
+
+          probe = @runner.call(%W[#{codex} --version])
+          return row("codex", "present", "codex at #{codex}") if probe[:success]
+
+          # Same as check_claude: `--version` is not an auth check.
+          row("codex", "broken", "codex at #{codex} failed to run (--version)",
+              fix: "reinstall OpenAI Codex (see install.md)")
+        end
+
+        def check_node
+          node = @which.call("node")
+          return row("node", "missing", "node not on PATH",
+                     fix: "install Node.js LTS (see install.md); qmd needs it") unless node
+
+          row("node", "present", "node at #{node}")
+        end
+
+        def check_npm
+          npm = @which.call("npm")
+          return row("npm", "missing", "npm not on PATH",
+                     fix: "install Node.js LTS (see install.md)") unless npm
+
+          row("npm", "present", "npm at #{npm}")
+        end
+
+        def check_qmd
+          probe = qmd_probe
+          return probe if probe
+
+          row("qmd", "missing", "qmd is not installed or not discoverable",
+              fix: qmd_install_command, hive_owned: true)
+        end
+
+        def qmd_probe
+          env_qmd = ENV["HIVE_QMD_BIN"].to_s
+          qmd = (!env_qmd.empty? && File.executable?(env_qmd) && env_qmd) || @which.call("qmd")
+          return nil unless qmd
+
+          probe = @qmd_runner.call([ qmd, "--version" ])
+          return row("qmd", "present", "qmd #{probe[:out].strip} at #{qmd}") if probe[:success]
+
+          row("qmd", "missing", "qmd at #{qmd} failed to run",
+              fix: qmd_install_command, hive_owned: true)
+        end
+
+        def qmd_install_command
+          %(npm install --global --prefix "#{File.join(@data_home, 'qmd')}" @tobilu/qmd)
+        end
+
+        # The Rails web bundle is only probe-able (and only bootstrappable)
+        # for a real app dir — the "local web only from a source checkout /
+        # HIVEBOX_WEB_APP_DIR" posture (Open Question 1: the gem does not
+        # package web/).
+        def check_bundle
+          return row("web bundle", "not_applicable", "no Rails app dir (web/ or HIVEBOX_WEB_APP_DIR); local web serves only from a checkout",
+                     fix: nil, hive_owned: true) unless @app_dir && File.file?(File.join(@app_dir, "Gemfile"))
+
+          probe = @runner.call(%W[bundle check --gemfile=#{File.join(@app_dir, "Gemfile")}])
+          return row("web bundle", "present", "bundle OK in #{@app_dir}") if probe[:success]
+
+          row("web bundle", "bundle_failed", "web bundle not installed in #{@app_dir}",
+              fix: "cd #{@app_dir} && bundle install", hive_owned: true)
+        end
+
+        def check_sqlite
+          sqlite = @which.call("sqlite3")
+          return row("sqlite", "missing", "sqlite3 not on PATH",
+                     fix: "install sqlite3 (see install.md)") unless sqlite
+
+          row("sqlite", "present", "sqlite3 at #{sqlite}")
+        end
+
+        # ── Bootstrap (Hive-owned deps only) ───────────────────────────────
+        def bootstrap_hive_owned!
+          bootstrap_qmd!
+          bootstrap_bundle!
+        end
+
+        def bootstrap_qmd!
+          qmd_row = @rows.find { |r| r[:name] == "qmd" }
+          return unless qmd_row && qmd_row[:status] == "missing"
+
+          npm = @which.call("npm")
+          unless npm
+            @bootstrap_actions << { name: "qmd", action: "skip", status: "skipped",
+                                    detail: "npm missing; run #{qmd_row[:fix_command]} manually" }
+            return
+          end
+
+          probe = @runner.call(%W[npm install --global --prefix #{File.join(@data_home, "qmd")} @tobilu/qmd])
+          if probe[:success]
+            @bootstrap_actions << { name: "qmd", action: "install", status: "installed",
+                                    detail: "installed qmd via npm" }
+            @rows.map! { |r| r[:name] == "qmd" ? row("qmd", "present", "qmd installed (bootstrap)", hive_owned: true) : r }
+          else
+            @bootstrap_actions << { name: "qmd", action: "install", status: "failed",
+                                    detail: "npm install failed; run #{qmd_row[:fix_command]} manually" }
+            @rows.map! { |r| r[:name] == "qmd" ? r.merge(detail: "qmd install failed; run fix command manually") : r }
+          end
+        end
+
+        def bootstrap_bundle!
+          bundle_row = @rows.find { |r| r[:name] == "web bundle" }
+          return unless bundle_row && bundle_row[:status] == "bundle_failed"
+
+          probe = @runner.call(%W[bundle install --gemfile=#{File.join(@app_dir, "Gemfile")}])
+          if probe[:success]
+            @bootstrap_actions << { name: "web bundle", action: "install", status: "installed",
+                                    detail: "bundle installed in #{@app_dir}" }
+            @rows.map! { |r| r[:name] == "web bundle" ? row("web bundle", "present", "web bundle installed (bootstrap)", hive_owned: true) : r }
+          else
+            @bootstrap_actions << { name: "web bundle", action: "install", status: "failed",
+                                    detail: "bundle install failed; run `cd #{@app_dir} && bundle install` manually" }
+          end
+        end
+
+        def parse_cli_version(out)
+          m = out.to_s.match(/(\d+)\.(\d+)\.(\d+)/)
+          m && "#{m[1]}.#{m[2]}.#{m[3]}"
+        end
+
+        def envelope
+          {
+            "schema" => "hive-dependency-check",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-dependency-check"),
+            "ok" => @rows.all? { |r| !failing_row?(r) },
+            "rows" => @rows.map { |r| row_wire(r) },
+            "bootstrap" => @bootstrap_actions
+          }
+        end
+
+        def row_wire(row)
+          {
+            "name" => row[:name],
+            "status" => row[:status],
+            "detail" => row[:detail],
+            "fix_command" => row[:fix_command],
+            "hive_owned" => row[:hive_owned]
+          }
+        end
+
+        def render_table
+          @output.puts "hive setup: dependency check"
+          @rows.each do |r|
+            mark = %w[present not_applicable].include?(r[:status]) ? "ok" : r[:status]
+            line = "  #{mark.ljust(10)} #{r[:name]}"
+            line += " — #{r[:detail]}" if r[:detail]
+            @output.puts line
+            if r[:fix_command]
+              @output.puts "        fix: #{r[:fix_command]}"
+            end
+          end
+          @bootstrap_actions.each do |b|
+            @output.puts "  bootstrap #{b[:action].ljust(8)} #{b[:name]} (#{b[:status]}): #{b[:detail]}"
+          end
+        end
+      end
+    end
+  end
+end
